<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>18.1.2: <TT>short int</TT></title>
<link href="sx4aa.html" rev=precedes>
<link href="sx4ca.html" rel=precedes>
<link href="sx4a.html" rev=subdocument>
</head>
<body>
<H3>18.1.2: <TT>short int</TT></H3>

<p>Another type we haven't met is <TT>short int</TT>.
A <TT>short int</TT>
has the same guarantees as a plain <TT>int</TT>:
it will hold integers in at least the range +-32,767.
The difference between <TT>short int</TT> and plain <TT>int</TT>
is that <TT>short int</TT> <em>might</em> be smaller.
Remember, the definitions of both these types
(like all C types)
is that they have <em>at least</em> the specified range.
On some machines, plain <TT>int</TT> will hold numbers greater than 32,767.
(On 32-bit machines,
for example,
it's common for plain <TT>int</TT> to be 32 bits,
and to hold +-2,147,483,647.
Yes, this is all the way up to the minimum range
for a <TT>long int</TT>.)
You might use a <TT>short int</TT> when you had a lot of them
and were worried about saving memory.
If you had a large array of integers all less than 32,768,
or a large number of structures with one or more members holding
integers all less than 32,768,
you might declare the array or the structure members as <TT>short int</TT>,
to avoid devoting 4 bytes to each of them on 32-bit machines.
</p><hr>
<p>
Read sequentially:
<a href="sx4aa.html" rev=precedes>prev</a>
<a href="sx4ca.html" rel=precedes>next</a>
<a href="sx4a.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1996-1999
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
